app/banks/urls.py
from django.urls import path

from banks.views import BankList, BankCreate

app_name = 'bnk'

urlpatterns = [
    path('list/', BankList.as_view(), name='list'),
    path('create/', BankCreate.as_view(), name='create'),
]

app/clients/urls.py
from django.urls import path

from clients.views import ClientList, ClientCreate, ClientDetail, ClientUpdate, ClientDelete

app_name = 'cli'

urlpatterns = [
    path('list/', ClientList.as_view(), name='list'),
    path('create/', ClientCreate.as_view(), name='create'),
    path('detail/<int:pk>', ClientDetail.as_view(), name='detail'),
    path('update/<int:pk>', ClientUpdate.as_view(), name='update'),
    path('delete/<int:pk>', ClientDelete.as_view(), name='delete'),

]

app/credits/urls.py
from django.urls import path

from credits.views import CreditList, CreditCreate

app_name = 'cre'

urlpatterns = [
    path('list/', CreditList.as_view(), name='list'),
    path('create/', CreditCreate.as_view(), name='create'),
]

app/home/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.home, name='home'),
]

app/tu_credito/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('home.urls')),
    path('banks/', include('banks.urls')),
    path('clients/', include('clients.urls')),
    path('credits/', include('credits.urls')),
]

app/clients/models.py
from django.db import models
from django import forms
from django.urls import reverse

from banks.models import Bank
# Create your models here.


class Client(models.Model):
    """
    Client model
    """

    class PersonType(models.TextChoices):
        """
        Choices for person_type field
        """
        NAT = "NAT", "NATURAL"
        JUR = "JUR", "JURIDICA"

    name = models.CharField(
        null=False, blank=False,
        max_length=200,
        verbose_name="Nombre(s)",
        help_text="Nombre(s) del cliente"
    )
    last_name = models.CharField(
        null=False, blank=False,
        max_length=200,
        verbose_name="Apellido(s)",
        help_text="Apellido(s) del cliente"
    )
    birth_date = models.DateField(
        null=False, blank=False,
        verbose_name="Fecha de nacimiento",
        help_text="Fecha de nacimiento del cliente"
    )
    age = models.PositiveIntegerField(
        null=True, blank=True,
        verbose_name="Edad",
        help_text="Edad del cliente"
    )
    nationality = models.CharField(
        null=True, blank=True,
        max_length=255,
        verbose_name="Nacionalidad",
        help_text="Nacionalidad del cliente"
    )
    room_address = models.TextField(
        null=True, blank=True,
        verbose_name="Dirección de habitación",
        help_text="Dirección de habitación del cliente"
    )
    email = models.CharField(
        null=False, blank=False,
        max_length=255,
        verbose_name="Correo",
        help_text="Correo del cliente"
    )
    cellphone = models.CharField(
        null=True, blank=True,
        max_length=50,
        verbose_name="Teléfono",
        help_text="Teléfono del cliente"
    )
    person_type = models.CharField(
        null=True, blank=True,
        max_length=3,
        choices=PersonType.choices,
        verbose_name="Tipo",
        help_text="Tipo de persona"
    )
    bank = models.ForeignKey(
        Bank, on_delete=models.PROTECT,
        verbose_name="Banco",
        help_text="Banco del cliente"
    )

    class Meta:
        ordering = ['id']

    def get_person_type_value(self):
        return self.PersonType(self.person_type).label

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('cli:list')

app/clients/views.py

from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse
from django.views.generic import ListView, DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.contrib import messages

from clients.models import Client


# Create your views here.

class ClientList(ListView):
    """
    View for list Clients
    """
    model = Client
    template_name = 'clients/list.html'


class ClientDetail(DetailView):
    """
    View for detail Clients
    """
    model = Client
    template_name = 'clients/detail.html'


class ClientCreate(SuccessMessageMixin, CreateView):
    """
    View for create Clients
    """
    model = Client
    form = Client
    fields = "__all__"
    template_name = 'clients/create.html'
    success_message = 'Cliente creado exitosamente!!!'

    # Redirection after save
    def get_success_url(self):
        return reverse('cli:list')


class ClientUpdate(SuccessMessageMixin, UpdateView):
    model = Client
    form = Client
    fields = "__all__"
    template_name = 'clients/update.html'
    success_message = 'Cliente actualizado correctamente !!!'

    # Redirection after update
    def get_success_url(self):
        return reverse('cli:list')


class ClientDelete(SuccessMessageMixin, DeleteView):
    model = Client
    form = Client
    fields = "__all__"

    # Redirection after delete
    def get_success_url(self):
        success_message = 'Cliente eliminado correctamente !'
        messages.success(self.request, success_message)
        return reverse('cli:list')

app/clients/templates/clients/create.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>Tú Crédito</title>
        {% load bootstrap4 %}
        {% bootstrap_css %}
        {% load widget_tweaks %}
        {% load static %}
    </head>
    <body>
        <header>
            <!-- Navigation menu -->
            <div class="container">
                <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="navbarNav">
                        <ul class="navbar-nav">
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'home' %}">Inicio </a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'bnk:list' %}">Bancos</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link active" href="{% url 'cli:list' %}">Clientes <span class="sr-only">(current)</span></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'cre:list' %}">Créditos</a>
                            </li>
                        </ul>
                    </div>
                </nav>
            </div>
        </header>
        <!-- Form create client -->
        <div class="container mt-5">
            <form method="post" enctype="multipart/form-data" class="border rounded p-3">
                {% csrf_token %}
                <div class="row">
                    <!-- Field names -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Nombre(s):</label>
                            {{ form.name|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field last name -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Apellidos(s):</label>
                            {{ form.last_name|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field birthdate -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Fecha de nacimiento:</label>
                            {% render_field form.birth_date type="date" class="form-control" %}
                        </div>
                    </div>
                    <!-- Field age -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Edad:</label>
                            {{ form.age|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field email -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Correo:</label>
                            {{ form.email|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field cellphone -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Teléfono:</label>
                            {{ form.cellphone|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field person type -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Tipo de persona:</label>
                            {{ form.person_type|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field bank -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Banco:</label>
                            {{ form.bank|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field nationality -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Nacionalidad:</label>
                            {{ form.nationality|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field room address -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Dirección de habitación:</label>
                            {{ form.room_address|add_class:"form-control" |attr:"rows:4" }}
                        </div>
                    </div>
                </div>
                <!-- Save button -->
                <button type="submit" class="btn btn-success">Aceptar</button>
                <!-- Cancel button -->
                <a href="{% url 'cli:list' %}"  type="submit" class="btn btn-danger">Cancelar</a>
            </form>
        </div>

        {% bootstrap_javascript jquery='full' %}
    </body>
</html>

app/clients/templates/clients/detail.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>Tú Crédito</title>
        {% load bootstrap4 %}
        {% bootstrap_css %}
        {% load widget_tweaks %}
        {% load static %}
    </head>
    <body>
        <header>
            <!-- Navigation menu -->
            <div class="container">
                <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="navbarNav">
                        <ul class="navbar-nav">
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'home' %}">Inicio </a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'bnk:list' %}">Bancos</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link active" href="{% url 'cli:list' %}">Clientes <span class="sr-only">(current)</span></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'cre:list' %}">Créditos</a>
                            </li>
                        </ul>
                    </div>
                </nav>
            </div>
        </header>
        <!-- Client information -->
        <div class="container mt-5 border rounded p-3">
            <div class="row">
                <!-- Field names -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Nombre(s):</label>
                       {{ object.name }}
                    </div>
                </div>
                <!-- Field lastname -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Apellidos(s):</label>
                       {{ object.last_name }}
                    </div>
                </div>
                <!-- Field birthdate -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Fecha de nacimiento:</label>
                       {{ object.birth_date |date:"M d, Y" }}
                    </div>
                </div>
            </div>
            <hr>
            <div class="row">
                <!-- Field age -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Edad:</label>
                       {{ object.age }}
                    </div>
                </div>
                <!-- Field nationality -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Nacionalidad:</label>
                       {{ object.nationality }}
                    </div>
                </div>
                <!-- Field room address -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Dirección de habitación:</label>
                       {{ object.room_address }}
                    </div>
                </div>
            </div>
            <hr>
            <div class="row">
                <!-- Field email -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Correo:</label>
                       {{ object.email }}
                    </div>
                </div>
                <!-- Field cellphone -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Teléfono:</label>
                       {{ object.cellphone }}
                    </div>
                </div>
                <!-- Field person type -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Tipo de persona:</label>
                       {{ object.get_person_type_value }}
                    </div>
                </div>
            </div>
            <hr>
            <div class="row">
                <!-- Field bank -->
                <div class="col">
                    <div class="form-group">
                        <label class="font-weight-bold">Banco:</label>
                       {{ object.bank }}
                    </div>
                </div>
            </div>

            <!-- Back button -->
            <a href="{% url 'cli:list' %}"  type="submit" class="btn btn-secondary">Volver</a>
        </div>

        {% bootstrap_javascript jquery='full' %}
    </body>
</html>

app/clients/templates/clients/list.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>Tú Crédito</title>
        {% load bootstrap4 %}
        {% bootstrap_css %}
        {% load static %}
    </head>
    <body>
        <header>
            <!-- Navigation menu -->
            <div class="container">
                <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="navbarNav">
                        <ul class="navbar-nav">
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'home' %}">Inicio </a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'bnk:list' %}">Bancos</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link active" href="{% url 'cli:list' %}">Clientes <span class="sr-only">(current)</span></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'cre:list' %}">Créditos</a>
                            </li>
                        </ul>
                    </div>
                </nav>
            </div>
        </header>
        <div class="container mt-3">
            <div class="row">
                <!-- Messages -->
                <div class="col-lg-4">
                    {% if messages %}
                        <ul class="messages list-group mb-3">
                            {% for message in messages %}
                                <li {% if message.tags %} class="{{ message.tags }} list-group-item list-group-item-success text-center" {% endif %}>
                                    {{ message }}
                                </li>
                            {% endfor %}
                        </ul>
                    {% endif %}
                </div>
                <!-- Create button -->
                <div class="col-lg-8">
                    <div class="btn_crear">
                        <a href="{% url 'cli:create' %}" type="button" class="btn btn-primary float-right mb-3">Crear</a>
                    </div>
                </div>
            </div>
            <!-- List of Clients -->
            <table class="table table-striped table-hover">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Nombres</th>
                        <th>Apellidos</th>
                        <th>Correo</th>
                        <th>Acciones</th>
                    </tr>
                </thead>
                <tbody>
                    {% for client in object_list %}
                    <tr>
                        <td>{{ forloop.counter }}</td>
                        <td>{{ client.name }}</td>
                        <td>{{ client.last_name }}</td>
                        <td>{{ client.email }}</td>
                        <td>
                            <!-- Actions -->
                            <form method="POST" action="{% url 'cli:delete' client.pk %}">
                                {% csrf_token %}
                                <div class="btn-group">
                                    <!-- View detail Client -->
                                    <a href="{% url 'cli:detail' client.pk %}" title="Ver" type="button" class="btn btn-info">Ver</a>
                                    <!-- Edit Client -->
                                    <a href="{% url 'cli:update' client.pk %}" title="Editar" type="button" class="btn btn-success">Editar </a>
                                    <!-- Delete Client -->
                                    <button class="btn btn-danger" onclick="return eliminar();" type="submit">Eliminar</button>
                                </div>
                            </form>
                        </td>
                    </tr>
                  {% endfor %}
                  </tbody>
            </table>
        </div>
        <script type="text/javascript">
            function eliminar() {
                return confirm("Eliminar Cliente ?");
      }
    </script>

        {% bootstrap_javascript jquery='full' %}
    </body>
</html>

app/clients/templates/clients/update.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>Tú Crédito</title>
        {% load bootstrap4 %}
        {% bootstrap_css %}
        {% load widget_tweaks %}
        {% load static %}
    </head>
    <body>
        <header>
            <!-- Navigation menu -->
            <div class="container">
                <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="navbarNav">
                        <ul class="navbar-nav">
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'home' %}">Inicio </a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'bnk:list' %}">Bancos</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link active" href="{% url 'cli:list' %}">Clientes <span class="sr-only">(current)</span></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'cre:list' %}">Créditos</a>
                            </li>
                        </ul>
                    </div>
                </nav>
            </div>
        </header>
        <!-- Form update client -->
        <div class="container mt-5">
            <form method="post" enctype="multipart/form-data" class="border rounded p-3">
                {% csrf_token %}
                <div class="row">
                    <!-- Field names -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Nombre(s):</label>
                            {{ form.name|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field last name -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Apellidos(s):</label>
                            {{ form.last_name|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field birthdate -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Fecha de nacimiento:</label>
                            {% render_field form.birth_date type="date" class="form-control" %}
                        </div>
                    </div>
                    <!-- Field age -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Edad:</label>
                            {{ form.age|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field email -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Correo:</label>
                            {{ form.email|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field cellphone -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Teléfono:</label>
                            {{ form.cellphone|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field person type -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Tipo de persona:</label>
                            {{ form.person_type|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field bank -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Banco:</label>
                            {{ form.bank|add_class:"form-control" }}
                        </div>
                    </div>
                </div>
                <div class="row">
                    <!-- Field nationality -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Nacionalidad:</label>
                            {{ form.nationality|add_class:"form-control" }}
                        </div>
                    </div>
                    <!-- Field room address -->
                    <div class="col">
                        <div class="form-group">
                            <label class="font-weight-bold">Dirección de habitación:</label>
                            {{ form.room_address|add_class:"form-control" |attr:"rows:4" }}
                        </div>
                    </div>
                </div>
                <!-- Save button -->
                <button type="submit" class="btn btn-success">Aceptar</button>
                <!-- Cancel button -->
                <a href="{% url 'cli:list' %}"  type="submit" class="btn btn-danger">Cancelar</a>
            </form>
        </div>

        {% bootstrap_javascript jquery='full' %}
    </body>
</html>